summaryrefslogtreecommitdiffstats
path: root/extra/source/llvm13-compat/llvm13-compat.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'extra/source/llvm13-compat/llvm13-compat.SlackBuild')
-rwxr-xr-xextra/source/llvm13-compat/llvm13-compat.SlackBuild118
1 files changed, 118 insertions, 0 deletions
diff --git a/extra/source/llvm13-compat/llvm13-compat.SlackBuild b/extra/source/llvm13-compat/llvm13-compat.SlackBuild
new file mode 100755
index 000000000..f0f432654
--- /dev/null
+++ b/extra/source/llvm13-compat/llvm13-compat.SlackBuild
@@ -0,0 +1,118 @@
+#!/bin/bash
+
+# Copyright 2024 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PKGNAM=llvm13-compat
+VERSION=${VERSION:-13.0.0}
+BUILD=${BUILD:-1_slack15.0}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
+NUMJOBS=${NUMJOBS:-" -j $(expr $(nproc) + 1) "}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PKGNAM
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+# Create a directory for the libraries:
+mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}
+
+echo "Copying list of directly-linked libraries..."
+cat $CWD/llvm13-list-of-libraries-to-retain | while read library ; do
+ if [ ! "$(echo $library | cut -c 1)" = "#" ]; then
+ if [ ! -e /usr/lib${LIBDIRSUFFIX}/$library ]; then
+ echo "ERROR: llvm 13 package must be installed so that we can extract libraries from the system."
+ exit 1
+ fi
+ cp -a -v /usr/lib${LIBDIRSUFFIX}/$library $PKG/usr/lib${LIBDIRSUFFIX}
+ if [ -L /usr/lib${LIBDIRSUFFIX}/$library ]; then
+ cp -a /usr/lib${LIBDIRSUFFIX}/$(readlink /usr/lib${LIBDIRSUFFIX}/$library) $PKG/usr/lib${LIBDIRSUFFIX}
+ fi
+ fi
+done || exit 1
+
+echo "Copying other LLVM libraries required by the already copied ones..."
+cd $PKG/usr/lib${LIBDIRSUFFIX}
+touch $PKG/scan
+while [ -e $PKG/scan ]; do
+ # we'll reset this flag if we find something. We need to make one pass without
+ # finding anything to leave this loop.
+ rm $PKG/scan
+ for library in lib* ; do
+ readelf -d $library | grep "Shared library" | rev | cut -f 1 -d ' ' | rev | tr -d \[ | tr -d \] | grep ".so.13$" | while read dep ; do
+ if [ ! -e $dep ]; then
+ echo "Copying $dep for $library..."
+ cp -a -v /usr/lib${LIBDIRSUFFIX}/$dep $PKG/usr/lib${LIBDIRSUFFIX}
+ if [ -L /usr/lib${LIBDIRSUFFIX}/$dep ]; then
+ cp -a /usr/lib${LIBDIRSUFFIX}/$(readlink /usr/lib${LIBDIRSUFFIX}/$dep) $PKG/usr/lib${LIBDIRSUFFIX}
+ fi
+ touch $PKG/scan
+ fi
+ done
+ done
+done
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/$PKGNAM-$VERSION-$ARCH-$BUILD.txz